<?php

/*

 +-------------------------------------------------------------------+
 |   Squarely v1.0.2 - (30/05/2010)                                  |
 +-------------------------------------------------------------------+
 |   Script PHP de Galerie Photo                                     |
 |   2007 Jean-Charles Pernot                                        |
 |   2009 Pierre Jarillon                                            |
 |   Email : moog+squarely@agmen.fr                                  |
 |   Site Web : http://www.agmen.fr/squarely/                        |
 +-------------------------------------------------------------------+
 |   + JavaScript : Bulle // Nice Titles                             |
 |        - Sources http://kryogenix.org/code/browser/nicetitle/     |
 |        - Sources http://traaaz.free.fr/bulle/                     |
 +-------------------------------------------------------------------+
 | This program is free software; you can redistribute it and/or     |
 | modify it under the terms of the GNU General Public License       |
 | as published by the Free Software Foundation; either version 2    |
 | of the License, or (at your option) any later version.            |
 |                                                                   |
 | This program is distributed in the hope that it will be useful,   |
 | but WITHOUT ANY WARRANTY; without even the implied warranty of    |
 | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     |
 | GNU General Public License for more details.                      |
 |                                                                   |
 | You should have received a copy of the GNU General Public License |
 | along with this program; if not, write to the Free Software       |
 | Foundation, Inc., 59 Temple Place                                 |
 | Suite 330, Boston, MA  02111-1307, USA.                           |
 +-------------------------------------------------------------------+
 |   Partie II - GenMiniature.php                                    |
 +-------------------------------------------------------------------+

*/

  ## Sessions PHP - //session_start(); - A commenter si session.auto_start est activ
  session_start();

  // Rcupration des variables GET
  $PHOTO = $_GET["PHOTO"];
    if(!preg_match("/^[-_.[:alnum:]]{5,100}$/",$PHOTO)) { die; }

  // Extensions valides
  if(substr(strtolower($PHOTO),-4) == ".jpg") { $EXT='jpeg'; }
  elseif(substr(strtolower($PHOTO),-4) == ".png") { $EXT='png'; }
  elseif(substr(strtolower($PHOTO),-4) == ".gif") { $EXT='gif'; }
  elseif(substr(strtolower($PHOTO),-5) == ".wbmp") { $EXT='wbmp'; }
  else { die; }

  // Vrifications et Dclaration de la fonction
  if((is_file($PHOTO) AND !is_file('Mini/Mn_'.$PHOTO)) OR (is_file($PHOTO) AND ($_SESSION['NeW_'.$PHOTO] == "REFAIRE"))) 
               {
               $_SESSION['NeW_'.$PHOTO] = "REFAITE" ;
               // Modification du Fichier DERN_MOD pour les derniers ajouts/modifs
               unlink("DERN_MOD");
               $DERN_MOD = fopen("DERN_MOD", 'w');
               fclose($DERN_MOD);
               // Cration des images
               GenMiniature($PHOTO,$EXT,$_SESSION['COTE'],$_SESSION['Rcol'],$_SESSION['Gcol'],$_SESSION['Bcol'],$_SESSION['MAXRz'],$_SESSION['QUALITEJPG']);
               }
  else { die; }


      ## Fonction de cration des vignettes jpg, gif, png et wbmp
      function GenMiniature($PHOTO,$EXT,$COTE,$R,$G,$B,$MAXRz,$QUALITEJPG)
            {
            // Dimensions de la photo originale
               list($LARGEUR_ORIGINE,$HAUTEUR_ORIGINE) = getimagesize($PHOTO);
               if($LARGEUR_ORIGINE >= $HAUTEUR_ORIGINE) {
                                   $RZ_LARG = $MAXRz;
                                   $RZ_HAUT = round(($MAXRz/$LARGEUR_ORIGINE)* $HAUTEUR_ORIGINE,0) ;
                                   }
                                   else  { 
                                         $RZ_HAUT = $MAXRz;
                                         $RZ_LARG = round(($MAXRz/$HAUTEUR_ORIGINE)* $LARGEUR_ORIGINE,0) ;
                                         }
            // Cration de l'image et de la vignette
               header('Content-type: image/'.$EXT);
               $VIGN_NEW = imagecreatetruecolor($COTE, $COTE);
               $PHOTO_NEW = imagecreatetruecolor($RZ_LARG, $RZ_HAUT);
               $bgcolorV  = imagecolorallocate($VIGN_NEW,$R,$G,$B);
               $bgcolorR  = imagecolorallocate($PHOTO_NEW,$R,$G,$B);
               imagefilledrectangle($VIGN_NEW, 0, 0,$COTE,$COTE,$bgcolorV);
               imagefilledrectangle($PHOTO_NEW, 0, 0,$RZ_LARG,$RZ_HAUT,$bgcolorR);
            // Gestion des ombres
               $Rs = $R-30; if($Rs<0){ $Rs=0 ; }
               $Gs = $G-30; if($Gs<0){ $Rs=0 ; }
               $Bs = $B-30; if($Bs<0){ $Rs=0 ; }
               $bgcolorShV  = imagecolorallocate($VIGN_NEW,$Rs,$Gs,$Bs);
               imagefilledrectangle($VIGN_NEW,1,1,$COTE-4,$COTE-4,$bgcolorShV); 
               $bgcolorShR  = imagecolorallocate($VIGN_NEW,$Rs,$Gs,$Bs);
               imagefilledrectangle($PHOTO_NEW,1,1,$RZ_LARG-4,$RZ_HAUT-4,$bgcolorShR);
            // Format de l'image
               if($EXT == 'jpeg') { $vign = imagecreatefromjpeg($PHOTO); $photo = imagecreatefromjpeg($PHOTO); }
               if($EXT == 'png') { $vign = imagecreatefrompng($PHOTO); $photo = imagecreatefrompng($PHOTO); }
               if($EXT == 'gif') { $vign = imagecreatefromgif($PHOTO); $photo = imagecreatefromgif($PHOTO); }
               if($EXT == 'wbmp') { $vign = imagecreatefromwbmp($PHOTO); $photo = imagecreatefromwbmp($PHOTO);}
            // Reajustage
               imagecopyresampled($VIGN_NEW, $vign, 0, 0, 0, 0, $COTE-5, $COTE-5, $LARGEUR_ORIGINE, $HAUTEUR_ORIGINE);
               imagecopyresampled($PHOTO_NEW, $photo, 0, 0, 0, 0, $RZ_LARG-5, $RZ_HAUT-5, $LARGEUR_ORIGINE, $HAUTEUR_ORIGINE);
            // Affichage de l'image generee
               if($EXT == 'jpeg') {
                       imagejpeg($VIGN_NEW,null,$QUALITEJPG);
                       imagejpeg($VIGN_NEW, 'Mini/Mn_'.$PHOTO, $QUALITEJPG);
                    // Destruction de la vignette
                       imagedestroy($VIGN_NEW);
                       imagejpeg($PHOTO_NEW, 'Med/Rz_'.$PHOTO, $QUALITEJPG);
                       }
               if($EXT == 'png') {
                       imagepng($VIGN_NEW); 
                       imagepng($VIGN_NEW,'Mini/Mn_'.$PHOTO); 
                    // Destruction de la vignette
                       imagedestroy($VIGN_NEW);
                       imagepng($PHOTO_NEW, 'Med/Rz_'.$PHOTO);
                       }
               if($EXT == 'gif') { 
                       imagegif($VIGN_NEW);
                       imagegif($VIGN_NEW, 'Mini/Mn_'.$PHOTO);
                    // Destruction de la vignette
                       imagedestroy($VIGN_NEW);
                       imagegif($PHOTO_NEW, 'Med/Rz_'.$PHOTO);
                       }
               if($EXT == 'wbmp') { 
                       imagewbmp($VIGN_NEW);
                       imagewbmp($VIGN_NEW, 'Mini/Mn_'.$PHOTO); 
                    // Destruction de la vignette
                       imagedestroy($VIGN_NEW);
                       imagewbmp($PHOTO_NEW, 'Med/Rz_'.$PHOTO);
                       }
            // Destruction de la prvisualisation
               imagedestroy($PHOTO_NEW);

            // Cration du Fichier Med/$PHOTO.txt pour le comptage des visites
            if(!is_file("Med/$PHOTO.txt")) {
                            $fpNewVis = fopen("Med/$PHOTO.txt","w+");
                            fwrite($fpNewVis, "0");
                            fclose($fpNewVis);
                            }
            }   

?>
